#include <stdio.h>
#include <time.h>

#if defined(vms) || defined(SYSTEM_FIVE) || defined(sgi)
#define SHORT
#endif

#if !(defined(SHORT)  || defined(__osf__))
#include <string.h>
#define STRLEN(x)  ((x) == NULL ? 0 : strlen(x))
#endif

#define PE         (void)fprintf(stderr,
#define DATELEN  43

char *DateAndTime()
/*===============*/
{
int len;
static char dateTime[DATELEN];
struct tm *tms;
time_t seconds;
static char mon[12][10] = { "January","February","March","April","May",
			    "June","July","August","September",
                            "October","November","December" },
	    day[7][10] = { "Sunday","Monday","Tuesday","Wednesday",
			   "Thursday","Friday","Saturday" };

(void)time(&seconds);
tms = localtime(&seconds);

#ifdef SHORT
if( (len = sprintf(dateTime,"%s, %d %s %d, %d:%02d:%02d",
   day[tms->tm_wday], tms->tm_mday, mon[tms->tm_mon],
   1900 + tms->tm_year, tms->tm_hour, tms->tm_min, tms->tm_sec)
   ) >= DATELEN)
#elif defined(__osf__)
if( (len = sprintf(dateTime,"%s, %d %s %d, %d:%02d:%02d %s",
   day[tms->tm_wday], tms->tm_mday, mon[tms->tm_mon],
   1900 + tms->tm_year, tms->tm_hour, tms->tm_min, tms->tm_sec,
   tms->tm_zone)) >= DATELEN)
#else  /* for example, Ultrix, SUN */
if( (len = STRLEN(sprintf(dateTime,"%s, %d %s %d, %d:%02d:%02d",
   day[tms->tm_wday], tms->tm_mday, mon[tms->tm_mon],
   1900 + tms->tm_year, tms->tm_hour, tms->tm_min, tms->tm_sec))) >= DATELEN)
#endif
    { PE" DateAndTime: DATELEN must be increased at least to %d!!!\n",
                                                              len + 1);
      exit(1);
    }
return(dateTime);
}


/**********************************************************************

An alternative definition:

#include <stdio.h>
#include <time.h>

char *DateAndTime(void)
{
time_t seconds;
(void)time(&seconds);
return(asctime(localtime(&seconds)));
}

***********

or if time is not available on your system, just use the following:

#include <stdio.h>

char *DateAndTime(void)
{
return((char *)NULL);
}

************************************************************************/
