/* This program reads in a density file (for harmonic oscillator),
    calculates differences of densities for coordinates with oposite
    sites, and prints the differences into a file "diff"+orignnal filename.

    It is only assumed that first all negative coordinates are listed,
    and only then the positive ones.
*/
#include <stdio.h>                  
#include <math.h>                   
#include <string.h>

#define PE         (void)fprintf(stderr,
#define PO         (void)fprintf(Output,

#define FC         (void)fclose(

#define MDIM 30

main(ac, av) int ac; char *av[];
/*============================*/
{
FILE  *fopen(), *Input, *Output;
double x[MDIM], dens[MDIM], stdDev = 0;
int i, j, N = 0, N1 = 0;
static char newName[100] = "diff";
extern void exit();

if(ac < 2) { PE"Usage: '%s filename'\n", av[0]);
	     exit(1);
	   }
(void)strcat(newName, av[1]);

if( (Input = fopen(av[1],"r")) == NULL) { PE"file %s could not be opened",
							av[1]);
					    exit(1);
					}
while(fscanf(Input,"%lg %lg\n", &x[N], &dens[N]) == 2) {
		N++;
		if(N > MDIM)  { PE"\nMDIM not sufficient!!!\n\n");
				exit(1);
			      }
}
FC Input);

for(i = 0; i < N; i++)
      for(j = i + 1; j < N; j++) 
		if(fabs(x[j] + x[i]) < .00001)
			 { N1++; dens[i] -= dens[j]; break; }

if( (Output = fopen(newName,"w")) == NULL) { PE"file %s could not be opened",
							  newName);
					     exit(1);
					   }
for(i = 0; i < N1; i++) PO"%.15g %.15g\n", x[i], dens[i]);
FC Output);

for(i = 0; i < N1; i++) stdDev += dens[i] * dens[i];
PE"\nStandard deviation = %g\n\n", stdDev / N1);
}
